# coding: utf-8

# GTO-MO-1-1 - Removed partial_header
# flake8: noqa

from datetime import date, datetime
import decimal
import functools
import io
import re
import typing
import typing_extensions
import uuid

import frozendict

from chkp_harmony_endpoint_management_sdk.generated.cloud import schemas


class PossibleOperationParams(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    class MetaOapg:
        
        class properties:
            informUser = schemas.BoolSchema
            allowPostpone = schemas.BoolSchema
        
            @staticmethod
            def schedulingType() -> typing.Type['PushOperationSchedulingType']:
                return PushOperationSchedulingType
            schedulingDateTime = schemas.DateTimeSchema
            updateFromEpServer = schemas.BoolSchema
            updateFromCpServer = schemas.BoolSchema
            amExternalSource = schemas.StrSchema
            generateActivityLogs = schemas.BoolSchema
            indicator = schemas.StrSchema
            
            
            class filesToRestore(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    items = schemas.StrSchema
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple[typing.Union[MetaOapg.items, str, ]], typing.List[typing.Union[MetaOapg.items, str, ]]],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'filesToRestore':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> MetaOapg.items:
                    return super().__getitem__(i)
            
            
            class forensicsRemediationItems(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['ForensicsRemediationItem']:
                        return ForensicsRemediationItem
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['ForensicsRemediationItem'], typing.List['ForensicsRemediationItem']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'forensicsRemediationItems':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'ForensicsRemediationItem':
                    return super().__getitem__(i)
            forceAppsShutdown = schemas.BoolSchema
            restoreFromQuarantine = schemas.BoolSchema
            moveToQuarantine = schemas.BoolSchema
            packageVersion = schemas.StrSchema
            originalTimeoutSeconds = schemas.Float64Schema
            __annotations__ = {
                "informUser": informUser,
                "allowPostpone": allowPostpone,
                "schedulingType": schedulingType,
                "schedulingDateTime": schedulingDateTime,
                "updateFromEpServer": updateFromEpServer,
                "updateFromCpServer": updateFromCpServer,
                "amExternalSource": amExternalSource,
                "generateActivityLogs": generateActivityLogs,
                "indicator": indicator,
                "filesToRestore": filesToRestore,
                "forensicsRemediationItems": forensicsRemediationItems,
                "forceAppsShutdown": forceAppsShutdown,
                "restoreFromQuarantine": restoreFromQuarantine,
                "moveToQuarantine": moveToQuarantine,
                "packageVersion": packageVersion,
                "originalTimeoutSeconds": originalTimeoutSeconds,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["informUser"]) -> MetaOapg.properties.informUser: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["allowPostpone"]) -> MetaOapg.properties.allowPostpone: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["schedulingType"]) -> 'PushOperationSchedulingType': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["schedulingDateTime"]) -> MetaOapg.properties.schedulingDateTime: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["updateFromEpServer"]) -> MetaOapg.properties.updateFromEpServer: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["updateFromCpServer"]) -> MetaOapg.properties.updateFromCpServer: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["amExternalSource"]) -> MetaOapg.properties.amExternalSource: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["generateActivityLogs"]) -> MetaOapg.properties.generateActivityLogs: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["indicator"]) -> MetaOapg.properties.indicator: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["filesToRestore"]) -> MetaOapg.properties.filesToRestore: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["forensicsRemediationItems"]) -> MetaOapg.properties.forensicsRemediationItems: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["forceAppsShutdown"]) -> MetaOapg.properties.forceAppsShutdown: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["restoreFromQuarantine"]) -> MetaOapg.properties.restoreFromQuarantine: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["moveToQuarantine"]) -> MetaOapg.properties.moveToQuarantine: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["packageVersion"]) -> MetaOapg.properties.packageVersion: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["originalTimeoutSeconds"]) -> MetaOapg.properties.originalTimeoutSeconds: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["informUser"], typing_extensions.Literal["allowPostpone"], typing_extensions.Literal["schedulingType"], typing_extensions.Literal["schedulingDateTime"], typing_extensions.Literal["updateFromEpServer"], typing_extensions.Literal["updateFromCpServer"], typing_extensions.Literal["amExternalSource"], typing_extensions.Literal["generateActivityLogs"], typing_extensions.Literal["indicator"], typing_extensions.Literal["filesToRestore"], typing_extensions.Literal["forensicsRemediationItems"], typing_extensions.Literal["forceAppsShutdown"], typing_extensions.Literal["restoreFromQuarantine"], typing_extensions.Literal["moveToQuarantine"], typing_extensions.Literal["packageVersion"], typing_extensions.Literal["originalTimeoutSeconds"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["informUser"]) -> typing.Union[MetaOapg.properties.informUser, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["allowPostpone"]) -> typing.Union[MetaOapg.properties.allowPostpone, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["schedulingType"]) -> typing.Union['PushOperationSchedulingType', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["schedulingDateTime"]) -> typing.Union[MetaOapg.properties.schedulingDateTime, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["updateFromEpServer"]) -> typing.Union[MetaOapg.properties.updateFromEpServer, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["updateFromCpServer"]) -> typing.Union[MetaOapg.properties.updateFromCpServer, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["amExternalSource"]) -> typing.Union[MetaOapg.properties.amExternalSource, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["generateActivityLogs"]) -> typing.Union[MetaOapg.properties.generateActivityLogs, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["indicator"]) -> typing.Union[MetaOapg.properties.indicator, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["filesToRestore"]) -> typing.Union[MetaOapg.properties.filesToRestore, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["forensicsRemediationItems"]) -> typing.Union[MetaOapg.properties.forensicsRemediationItems, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["forceAppsShutdown"]) -> typing.Union[MetaOapg.properties.forceAppsShutdown, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["restoreFromQuarantine"]) -> typing.Union[MetaOapg.properties.restoreFromQuarantine, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["moveToQuarantine"]) -> typing.Union[MetaOapg.properties.moveToQuarantine, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["packageVersion"]) -> typing.Union[MetaOapg.properties.packageVersion, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["originalTimeoutSeconds"]) -> typing.Union[MetaOapg.properties.originalTimeoutSeconds, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["informUser"], typing_extensions.Literal["allowPostpone"], typing_extensions.Literal["schedulingType"], typing_extensions.Literal["schedulingDateTime"], typing_extensions.Literal["updateFromEpServer"], typing_extensions.Literal["updateFromCpServer"], typing_extensions.Literal["amExternalSource"], typing_extensions.Literal["generateActivityLogs"], typing_extensions.Literal["indicator"], typing_extensions.Literal["filesToRestore"], typing_extensions.Literal["forensicsRemediationItems"], typing_extensions.Literal["forceAppsShutdown"], typing_extensions.Literal["restoreFromQuarantine"], typing_extensions.Literal["moveToQuarantine"], typing_extensions.Literal["packageVersion"], typing_extensions.Literal["originalTimeoutSeconds"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        informUser: typing.Union[MetaOapg.properties.informUser, bool, schemas.Unset] = schemas.unset,
        allowPostpone: typing.Union[MetaOapg.properties.allowPostpone, bool, schemas.Unset] = schemas.unset,
        schedulingType: typing.Union['PushOperationSchedulingType', schemas.Unset] = schemas.unset,
        schedulingDateTime: typing.Union[MetaOapg.properties.schedulingDateTime, str, datetime, schemas.Unset] = schemas.unset,
        updateFromEpServer: typing.Union[MetaOapg.properties.updateFromEpServer, bool, schemas.Unset] = schemas.unset,
        updateFromCpServer: typing.Union[MetaOapg.properties.updateFromCpServer, bool, schemas.Unset] = schemas.unset,
        amExternalSource: typing.Union[MetaOapg.properties.amExternalSource, str, schemas.Unset] = schemas.unset,
        generateActivityLogs: typing.Union[MetaOapg.properties.generateActivityLogs, bool, schemas.Unset] = schemas.unset,
        indicator: typing.Union[MetaOapg.properties.indicator, str, schemas.Unset] = schemas.unset,
        filesToRestore: typing.Union[MetaOapg.properties.filesToRestore, list, tuple, schemas.Unset] = schemas.unset,
        forensicsRemediationItems: typing.Union[MetaOapg.properties.forensicsRemediationItems, list, tuple, schemas.Unset] = schemas.unset,
        forceAppsShutdown: typing.Union[MetaOapg.properties.forceAppsShutdown, bool, schemas.Unset] = schemas.unset,
        restoreFromQuarantine: typing.Union[MetaOapg.properties.restoreFromQuarantine, bool, schemas.Unset] = schemas.unset,
        moveToQuarantine: typing.Union[MetaOapg.properties.moveToQuarantine, bool, schemas.Unset] = schemas.unset,
        packageVersion: typing.Union[MetaOapg.properties.packageVersion, str, schemas.Unset] = schemas.unset,
        originalTimeoutSeconds: typing.Union[MetaOapg.properties.originalTimeoutSeconds, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'PossibleOperationParams':
        return super().__new__(
            cls,
            *_args,
            informUser=informUser,
            allowPostpone=allowPostpone,
            schedulingType=schedulingType,
            schedulingDateTime=schedulingDateTime,
            updateFromEpServer=updateFromEpServer,
            updateFromCpServer=updateFromCpServer,
            amExternalSource=amExternalSource,
            generateActivityLogs=generateActivityLogs,
            indicator=indicator,
            filesToRestore=filesToRestore,
            forensicsRemediationItems=forensicsRemediationItems,
            forceAppsShutdown=forceAppsShutdown,
            restoreFromQuarantine=restoreFromQuarantine,
            moveToQuarantine=moveToQuarantine,
            packageVersion=packageVersion,
            originalTimeoutSeconds=originalTimeoutSeconds,
            _configuration=_configuration,
        )

from chkp_harmony_endpoint_management_sdk.generated.cloud.model.forensics_remediation_item import ForensicsRemediationItem
from chkp_harmony_endpoint_management_sdk.generated.cloud.model.push_operation_scheduling_type import PushOperationSchedulingType
